# HTTP Shortcuts for Android
<a href="https://http-shortcuts.rmy.ch/">
<img src="/Assets/logo.png" align="right" style="margin-left: 1em;"/>
</a>

![Version](https://img.shields.io/badge/version-1.35.0-green.svg)

A simple Android app that allows you to create shortcuts that can be placed on your home screen. Each shortcut, when clicked, triggers an HTTP request.

<a href="https://play.google.com/store/apps/details?id=ch.rmy.android.http_shortcuts">
<img alt="Get it on Google Play" src="http://steverichey.github.io/google-play-badge-svg/img/en_get.svg" width="280" />
</a>

Get it on the [Play Store](https://play.google.com/store/apps/details?id=ch.rmy.android.http_shortcuts) or [download the latest APK](https://github.com/Waboodoo/HTTP-Shortcuts/releases) directly.

Find more information and documentation on the [official website](https://http-shortcuts.rmy.ch/).

[Support this app](https://http-shortcuts.rmy.ch/support-me) by helping me [translate it](https://poeditor.com/join/project/8tHhwOTzVZ) or by becoming a [Beta Tester](https://play.google.com/apps/testing/ch.rmy.android.http_shortcuts)!

## Features
- HTTP and HTTPS
- GET, POST, PUT, DELETE, PATCH, HEAD, OPTIONS and TRACE
- Basic Authentication, Digest Authentication & Bearer Authentication
- Custom request headers
- Custom request body (text or from file)
- Upload files as form-data
- Option to accept all certificates (if you know what you're doing)
- Support for HTTP proxies
- Built-in icons, support for Ipack icons and custom icons
- Display response as a toast, window or dialog, or run silently
- Grouping into categories through tabs
- Value injection through variables (e.g., text, numbers, passwords, selections, colors, dates, …)
- Run arbitrary [JavaScript](https://http-shortcuts.rmy.ch/scripting) before & after execution, including special actions (e.g., vibrate, show toast, parse and process response…), 
- Import & Export in JSON or cURL format
- 3rd party integration (e.g. Tasker)
- Themes (with Dark Mode support)

## Screenshots

![Image](/Assets/Screenshots/01.png)
![Image](/Assets/Screenshots/02.png)
![Image](/Assets/Screenshots/03.png)
![Image](/Assets/Screenshots/04.png)
![Image](/Assets/Screenshots/05.png)
![Image](/Assets/Screenshots/06.png)
![Image](/Assets/Screenshots/07.png)
![Image](/Assets/Screenshots/08.png)
![Image](/Assets/Screenshots/09.png)
![Image](/Assets/Screenshots/10.png)
![Image](/Assets/Screenshots/11.png)
![Image](/Assets/Screenshots/12.png)
![Image](/Assets/Screenshots/13.png)
